Scriptname aaaRSLOnSpellCastScript extends ReferenceAlias

;aaaSpellLearningQuest Property QuestScript Auto


Event OnSpellCast(Form akSpell)
	

	GotoState("Busy")

if	playerref.GetEquippedSpell(0) == akSpell || playerref.GetEquippedSpell(1) == akSpell
	
	if (Utility.RandomInt() <= 5)

		spell RSLSpell = akSpell as spell
		String SpellSkill = RSLSpell.GetNthEffectMagicEffect(0).GetAssociatedSkill()
		Float SkillLv = 0
		Book SpellBook = none
	
		if SpellSkill == ("Destruction")

			SpellBook = aaaRSLDesBookListAll.GetAt(Utility.RandomInt(0, aaaRSLDesBookListAll.GetSize())) as book
			SkillLv = playerref.GetActorValue("Destruction")
			
		elseif SpellSkill == ("Conjuration")

			SpellBook = aaaRSLConBookListAll.GetAt(Utility.RandomInt(0, aaaRSLConBookListAll.GetSize())) as book
			SkillLv = playerref.GetActorValue("Conjuration")
			
		elseif SpellSkill == ("Restoration")
		
			SpellBook = aaaRSLResBookListAll.GetAt(Utility.RandomInt(0, aaaRSLResBookListAll.GetSize())) as book
			SkillLv = playerref.GetActorValue("Restoration")
			
		elseif SpellSkill == ("Alteration")

			SpellBook = aaaRSLAltBookListAll.GetAt(Utility.RandomInt(0, aaaRSLAltBookListAll.GetSize())) as book
			SkillLv = playerref.GetActorValue("Alteration")
				
		elseif SpellSkill == ("Illusion")

			SpellBook = aaaRSLIllBookListAll.GetAt(Utility.RandomInt(0, aaaRSLIllBookListAll.GetSize())) as book
			SkillLv = playerref.GetActorValue("Illusion")
		
		endif
	
		if SpellBook != none
	
			Spell LearningSpell = SpellBook.GetSpell()
		
			if (LearningSpell != None)
		
				int lv = LearningSpell.GetNthEffectMagicEffect(0).GetSkillLevel()
				Float SpellLv = lv
		
				if !(playerref.hasspell(LearningSpell)) && (SkillLv >= SpellLv)
					playerref.addspell(LearningSpell)
				endif
			
			endif
	
		endif
		
	endif
	
endif
	
	GotoState("")
	
EndEvent

State Busy
Event OnSpellCast(Form akSpell)
EndEvent
EndState

Actor property playerref Auto

FormList Property aaaRSLDesBookListAll Auto
FormList Property aaaRSLConBookListAll Auto
FormList Property aaaRSLResBookListAll Auto
FormList Property aaaRSLAltBookListAll Auto
FormList Property aaaRSLIllBookListAll Auto