Scriptname aaaRSLQuestScript extends Quest

Event OnInit()

	LoadFunc()

EndEvent


Function LoadFunc()

	if aaaRSLGlobalMain.GetValueInt() == 0
	
	Debug.Notification("Preparing Random Spell Learning...")

		int i = 1

		while (i > 0)

		if Game.GetModByName("SkyRe_Main.esp") < 255 && aaaRSLGlobalSkyRe.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(8)
			aaaRSLGlobalSkyRe.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution SkyRe Start")
			RSL()
		
		elseif Game.GetModByName("Requiem.esp") < 255 && aaaRSLGlobalRequiem.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(7)
			aaaRSLGlobalRequiem.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution Requiem Start")
			RSL()
	
		elseif Game.GetModByName("PerkusMaximus_Master.esp") < 255 && aaaRSLGlobalPerMa.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(6)
			aaaRSLGlobalPerMa.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution PerMa Start")
			RSL()

		elseif Game.GetModByName("Apocalypse - The Spell Package.esp") < 255 && aaaRSLGlobalApocalypse.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(5)
			aaaRSLGlobalApocalypse.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution Apocalypse Start")
			RSL()

		elseif Game.GetModByName("Colorful_Magic.esp") < 255 && aaaRSLGlobalColorfulMagic.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(4)
			aaaRSLGlobalColorfulMagic.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution Colorful_Magic Start")
			RSL()
			
		elseif Game.GetModByName("ForgottenMagic_Redone.esp") < 255 && aaaRSLGlobalForgottenMagicRedone.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(3)
			aaaRSLGlobalForgottenMagicRedone.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution ForgottenMagic_Redone Start")
			RSL()
			
		elseif Game.GetModByName("Some Spell Package.esp") < 255 && aaaRSLGlobalSomeSpellPackage.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(2)
			aaaRSLGlobalSomeSpellPackage.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution Some Spell Package Start")
			RSL()
		
		elseif aaaRSLGlobalOtherMOD.GetValueInt() == 0
			aaaRSLMODGlobal.SetValueInt(1)
			aaaRSLGlobalOtherMOD.SetValueInt(1)
			Debug.Notification("SpellLearning Distribution OtherMOD Start")
			RSL()
		
		else
			i -= 1

		endif

		endwhile
	
	RSLDistribution()
	
	endif

EndFunction



Function RSL()
	FormList aaaRSLList
	int mod = aaaRSLMODGlobal.GetValueInt()
	
	if mod == 8
		aaaRSLList = aaaRSLAllSpellBookListSkyRe
	elseif mod == 7
		aaaRSLList = aaaRSLAllSpellBookListRequiem
	elseif mod == 6
		aaaRSLList = aaaRSLAllSpellBookListPerMa
	elseif mod == 5
		aaaRSLList = aaaRSLAllSpellBookListApocalypse
	elseif mod == 4
		aaaRSLList = aaaRSLAllSpellBookListColorfulMagic
	elseif mod == 3
		aaaRSLList = aaaRSLAllSpellBookListForgottenMagicRedone
	elseif mod == 2
		;aaaRSLList = aaaRSLAllSpellBookListSomeSpellPackage
		aaaRSLList = Game.GetFormFromFile(0x046E1715, "Some Spell Package.esp") as FormList
	elseif mod == 1
		aaaRSLList = aaaRSLAllSpellBookListOtherMOD
	endif
	
	if aaaRSLList != none

	int i = aaaRSLList.GetSize() + 1

	while (i > -1)
		
		Book SpellBook = aaaRSLList.GetAt(i) as book

		if SpellBook != none && !aaaRSLAllSpellBookList.HasForm(SpellBook)
			aaaRSLAllSpellBookList.addForm(SpellBook)	
			String BookName = SpellBook.getname()
			Debug.Trace("RSL()  "+(BookName))
		endif
			
		i -= 1
	
	endwhile

	endif
	
EndFunction


Function RSLDistribution()

	
	int i = aaaRSLAllSpellBookList.GetSize() + 1
	
	while (i > -1)
	
		Book SpellBook = aaaRSLAllSpellBookList.GetAt(i) as book

		if SpellBook != none
			Spell LearningSpell = SpellBook.GetSpell()
			String BookName = SpellBook.getname()
			Debug.Trace("RSLDistribution() "+(BookName))
			if LearningSpell != none && LearningSpell as spell
				String Skill = LearningSpell.GetNthEffectMagicEffect(0).GetAssociatedSkill()
		
				if (skill == "Destruction") && !aaaRSLDesBookListAll.HasForm(SpellBook)
					aaaRSLDesBookListAll.addForm(SpellBook)

				elseif (skill == "Conjuration") && !aaaRSLConBookListAll.HasForm(SpellBook)
					aaaRSLConBookListAll.addForm(SpellBook)

				elseif (skill == "Restoration") && !aaaRSLResBookListAll.HasForm(SpellBook)
					aaaRSLResBookListAll.addForm(SpellBook)

				elseif (skill == "Alteration") && !aaaRSLAltBookListAll.HasForm(SpellBook)
					aaaRSLAltBookListAll.addForm(SpellBook)

				elseif (skill == "Illusion") && !aaaRSLIllBookListAll.HasForm(SpellBook)
					aaaRSLIllBookListAll.addForm(SpellBook)
				endif
				
			endif
			
		endif
	i -= 1
		
	endwhile
	
	Debug.Notification("Started Random Spell Learning!")

EndFunction


GlobalVariable Property aaaRSLGlobalMain Auto

GlobalVariable Property aaaRSLGlobalApocalypse Auto
GlobalVariable Property aaaRSLGlobalColorfulMagic Auto
GlobalVariable Property aaaRSLGlobalForgottenMagicRedone Auto
GlobalVariable Property aaaRSLGlobalSkyRe Auto
GlobalVariable Property aaaRSLGlobalRequiem Auto
GlobalVariable Property aaaRSLGlobalPerMa Auto
GlobalVariable Property aaaRSLGlobalSomeSpellPackage Auto


GlobalVariable Property aaaRSLGlobalOtherMOD Auto

GlobalVariable Property aaaRSLMODGlobal Auto

FormList Property aaaRSLAllSpellBookList Auto

FormList Property aaaRSLAllSpellBookListApocalypse Auto
FormList Property aaaRSLAllSpellBookListColorfulMagic Auto
FormList Property aaaRSLAllSpellBookListForgottenMagicRedone Auto
FormList Property aaaRSLAllSpellBookListPerMa Auto
FormList Property aaaRSLAllSpellBookListRequiem Auto
FormList Property aaaRSLAllSpellBookListSkyRe Auto
;FormList Property aaaRSLAllSpellBookListSomeSpellPackage Auto



FormList Property aaaRSLAllSpellBookListOtherMOD Auto


;FormList aaaRSLList

FormList Property aaaRSLAltBookListAll Auto
FormList Property aaaRSLConBookListAll Auto
FormList Property aaaRSLDesBookListAll Auto
FormList Property aaaRSLIllBookListAll Auto
FormList Property aaaRSLResBookListAll Auto